// ------------------------------------------------------------
// wi}bv
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
float4x4 mWVP;		// [JˉeԂւ̍Wϊ

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture DecaleMap;
sampler DecaleSamp = sampler_state
{
    Texture = <DecaleMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture DepthMap;
sampler DepthSamp = sampler_state
{
    Texture = <DepthMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture ColorMap;
sampler ColorSamp = sampler_state
{
    Texture = <ColorMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

// -------------------------------------------------------------
// -------------------------------------------------------------
// wi}bv쐬
// -------------------------------------------------------------
// -------------------------------------------------------------

// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Position		: POSITION;
	float2 Tex			: TEXCOORD0;
	float4 Pos			: TEXCOORD1;
};
// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Out.Position = mul( Pos, mWVP );
    
    Out.Tex = Tex;
    
    return Out;
}
// -------------------------------------------------------------
// sNZVF[_o̓f[^
// -------------------------------------------------------------
struct PS_OUTPUT {
	float4 Color  : COLOR0;
	float4 Depth  : COLOR1;
};
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
PS_OUTPUT PS ( VS_OUTPUT In ) {
	
	PS_OUTPUT Out = ( PS_OUTPUT ) 0;
	
	// ʏF
	Out.Color = tex2D( DecaleSamp, In.Tex );
	
	// [x
	float depth = In.Pos.z / In.Pos.w;
	Out.Depth.x = depth;
	Out.Depth.y = depth * 256.0;
	Out.Depth.z = depth * 256.0f * 256.0f;
	Out.Depth.w = 0.0f;
	Out.Depth = frac(Out.Depth);

    return Out;
}

// -------------------------------------------------------------
// -------------------------------------------------------------
// wi}bv𒣂
// -------------------------------------------------------------
// -------------------------------------------------------------

// -------------------------------------------------------------
// sNZVF[_o̓f[^
// -------------------------------------------------------------
struct PS_OUTPUT_Mapping {
	float4 Color  : COLOR0;
	float  Depth  : DEPTH;
};
// -------------------------------------------------------------
// sNZVF[_
// -------------------------------------------------------------
PS_OUTPUT_Mapping psMapping ( float4 Tex : TEXCOORD0 ) {
	
	PS_OUTPUT_Mapping Out = ( PS_OUTPUT_Mapping ) 0;
	
	// ʏF
	Out.Color = tex2D( ColorSamp, Tex );
	
	// [x
	float4 depth = tex2D( DepthSamp, Tex );
	Out.Depth = depth.x
			  + depth.y / 256.0f
			  + depth.z / (256.0f*256.0f);
	
    return Out;
}


// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0	// wĩ}bv̍쐬
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
        
        Sampler[0]  = (DecaleSamp);
    }
    pass P1	// wĩ}bv𒣂
    {
        PixelShader  = compile ps_2_0 psMapping();
    }
}
